/***********************************************************
 * Search.c
 * õ르ꥺ(cut)
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: Search.c,v 1.1 2000/07/26 12:39:11 satofumi Exp $
 **********************************************************/
#define _SEARCH_C_

#include "global.h"
#include "core.h"
#include "Main.h"
#include "Sef.h"
#include "Movable.h"
#include "Utility.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/* ѿ */
static int dph;	/* õ */
static int tsj_max;	/* ο */
static long SearchMin(long alpha,long beta);
static long SearchMax(long alpha,long beta);
static int TesujiMake(int *tsj_prev, int *tsj_next, int control);

extern int *fld;
extern KomaDef *kom;
/*------------------------------------------------------------Search.c */
/* Calc(sasite,tsj)
 * ڤˤŪɾͤη׻
 * in:	sasite	ؤ
 *		tsj		
 *		nextnum õڤο
 * out:	ɾ֤ͤ
 */
long
Calc(TesujiDef *sasite, int *tsj_prev, int *tsj_next, int nextnum)
{
	int i, dekoma, flag;
	long value;
	long alpha = SCORE_MAX;	/*  */
	long beta  = SCORE_MIN;	/*  */

	dph = 0;
	for( i=0; i<nextnum ;i++ ) {
		if( tsj_prev[i]!=tsj_next[i] ) {/* ưƤʤʤᡪ */
			/* ʤ */
			dekoma = fld[tsj_next[i]];
			flag = VirKomaMove( tsj_prev[i], tsj_next[i], gTeban_me );
			dph++;
			/* MIN ؿ */
			value = SearchMin( alpha, beta );
			/* ᤹ */
			VirKomaDisMove( tsj_prev[i], tsj_next[i], gTeban_me, dekoma, flag );
			dph--;
			if( value>beta ) {	/* ꤫ */
				beta = value;
				sasite->prev = tsj_prev[i];
				sasite->next = tsj_next[i];
			}
		}
	}
	return beta;
}


/* SearchMin(alpha,beta)
 * ɤλؤ(μ)
 * in:	alpha		
 *		beta		
 * out:	֤ͤ
 */
static long
SearchMin(long alpha, long beta)
{
	int i, dekoma, flag, nextnum;
	long value;
	int *tsj_prev;
	int *tsj_next;

	/* üʤɾ֤ͤ */
	if( dph>=gDepthMax[gTeban_me] || kz(0)>=HAND || kz(20)>=HAND ) {
		value = Sef( fld, kom );
		return value;
	}
	/* λؤϡ */
	tsj_max = gSasiteMax[gTeban_me] / dph;	/* ο */
	tsj_prev = (int *)TsjAlloc( tsj_max );	/* ڤγ */
	tsj_next = (int *)TsjAlloc( tsj_max );	/* ڤγ */
	nextnum = TesujiMake( tsj_prev, tsj_next, gTeban_you );/* ̾ڤ */
	for( i=0; i<nextnum; i++ ) {
		/* ʤ */
		dekoma = fld[tsj_next[i]];
		//printf( "MIN dph:%d,  %d: %d -> %d\n", dph,i,tsj_prev[i],tsj_next[i] );
		flag = VirKomaMove( tsj_prev[i], tsj_next[i], gTeban_you );
		dph++;
		/* MAX ؿ */
		value = SearchMax( alpha, beta );
		/* ᤹ */
		VirKomaDisMove( tsj_prev[i], tsj_next[i], gTeban_you, dekoma, flag );
		dph--;
		if( value<alpha ) alpha = value;
		if( alpha<=beta ) break;
	}
	TsjFree( tsj_prev, tsj_next );

	return (alpha);
}


/* SearchMax(alpha,beta)
 * ɤλؤ(Фμ)
 * in:	alpha		
 *		beta		
 * out:	֤ͤ
 */
static long
SearchMax(long alpha,long beta)
{
	int i, dekoma, flag, nextnum;
	long value;
	int *tsj_prev;
	int *tsj_next;

	/* üʤɾ֤ͤ */
	if( dph>=gDepthMax[gTeban_me] || kz(0)>=HAND || kz(20)>=HAND ) {
		value = Sef( fld, kom );
		return value;
	}
	/* Фλؤϡ */
	tsj_max = gSasiteMax[gTeban_me] / dph;	/* ο */
	tsj_prev = (int *)TsjAlloc( tsj_max );	/* ڤγ */
	tsj_next = (int *)TsjAlloc( tsj_max );	/* ڤγ */
	nextnum = TesujiMake( tsj_prev, tsj_next, gTeban_me );/* ̾ڤ */
	for( i=0; i<nextnum; i++ ) {
		/* ʤ */
		dekoma = fld[tsj_next[i]];
		//printf( "MAX dph:%d,  %d: %d -> %d\n", dph,i,tsj_prev[i],tsj_next[i] );
		flag = VirKomaMove( tsj_prev[i], tsj_next[i], gTeban_me );
		dph++;
		/* MIN ؿ */
		value = SearchMin( alpha, beta );
		/* ᤹ */
		VirKomaDisMove( tsj_prev[i], tsj_next[i], gTeban_me, dekoma, flag );
		dph--;
		if( value>beta ) beta = value;
		if( alpha<=beta ) break;
	}
	TsjFree( tsj_prev, tsj_next );

	return (beta);
}


/* TesujiMake(tsj_prev,tsj_next,control)
 * Ūʼڤ
 * in:	tsj_prev, tsj_next		
 *		control		ïμڤ
 * out:	ڤο
 */
static int
TesujiMake(int *tsj_prev, int *tsj_next, int control)
{
	int i,j,m;
	int num=0;
	TesujiDef vtsj[TESUJI_MAX];

	/* μ */
	j = king_you(control);
	for( i=0;i<KOMA_NUM && num<TESUJI_MAX;i++ ) {
		if( kz(i)<HAND && kc(i)==control ) {
			if( Movable( kz(i), kz(j), fld, kom ) ){
				vtsj[num].prev = kz(i);
				vtsj[num].next = kz(j);
				vtsj[num].value= Tef( fld, kom, kz(i), kz(j) );
				num++;
			}
		}
	}
	/* ꤬ʤ */
	if( num==0 ) {
	/* Ƥζưμ */
	for( j=0;j<KOMA_NUM && num<TESUJI_MAX;j++ ) { /*  */
		if( kz(j)<HAND && kc(j)==control ) {
			for( i=0; i<BAN_NUM && num<TESUJI_MAX; i++) { /*  */
				if( Movable( kz(j), i, fld, kom ) ) {
					vtsj[num].prev = kz(j);
					vtsj[num].next = i;
					vtsj[num].value= Tef(fld,kom,kz(j),i);
					num++;
				}
			}
		}
	}
	/* Ǥμ(ޤ) */
	if( dph<2 && ( fld[gStock_me]!=NONE || fld[gStock_you]!=NONE ) ){
	    int type=NO_TYPE;	/* ƱФʤ褦 */
		TesujiDef vvtsj[ BAN_NUM ];/* ڤ */
		for( j=0;j<KOMA_NUM && num<TESUJI_MAX;j++ ) {
			if( kz(j)>HAND && kc(j)==control ) {
				int t=0;
				if( kom[j].type!=type ) {
					for( i=0; i<BAN_NUM; i++) {
						if( fld[i]==NONE ) {
							vvtsj[t].prev = kz(j);
							vvtsj[t].next = i;
							vvtsj[t].value= Tef(fld,kom,kz(j),i);
							t++;
						}
					}
				}
				TesujiSort( vvtsj, t );
				if( t>=2 ) t=2;
				for( m=0; m<t && num<TESUJI_MAX ;m++ ){
					TsjCopy( &vtsj[num], &vvtsj[m] );
					num++;
				}
				type = kom[j].type;
			}
		}
	}
	}	/* end of ʤ */

	/* ƱڤϾõ */
	for( i=0; i<(TESUJI_MAX)-1; i++ ) {
		for( j=i+1; j<TESUJI_MAX; j++ ) {
			if(vtsj[i].prev==vtsj[j].prev
									 && vtsj[i].next==vtsj[j].next ){
				vtsj[j].prev = 0;
				vtsj[j].next = 0;
				vtsj[j].value= 0;
			}
		}
	}
	/*  */
	if( num!=0 ) TesujiSort( vtsj, num );
	/* ڤΥåȳ */
	m = 0;
	for( i=0; i<num && i<TESUJI_MAX && m<tsj_max; i++ ) {
		if( TsjCheck(vtsj[i].prev, vtsj[i].next) ) {
			tsj_prev[m] = vtsj[i].prev;
			tsj_next[m] = vtsj[i].next;
			m++;
		}
	}

	return m;
}
