/***********************************************************
 * Sef.c
 * Ūɾؿ(Static Evaluation Function)
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: Sef.c,v 1.1 2000/07/26 12:39:11 satofumi Exp $
 **********************************************************/
#define _SEF_C_

#include "global.h"
#include "core.h"
#include "Main.h"
#include "Sef.h"
#include "Movable.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <math.h>


/* ؿ */
static int MeasureX(int zahyo1, int zahyo2);
static int MeasureY(int zahyo1, int zahyo2);
static int Kiki(int *fld, KomaDef *kom, int zahyo, int control);

/*------------------------------------------------------------algosef.c */
/* Sef(fld,kom)
 * Ūɾؿ(Static Evaluation Function)
 * in:	fld		۶
 *		kom		۶
 * out:			׻
 */
long
Sef(int *fld, KomaDef *kom)
{
	int i,j;
	long result[FACTOR];
	int coef[FACTOR];
	long sum = 0;

	/*  */
	switch( gSituation ) {
		case JOBAN:
			coef[0] = gSef_SefCoef[gTeban_me][JOBAN][0];	/* Ȥ */
			coef[1] = gSef_SefCoef[gTeban_me][JOBAN][1];	/*  */
			coef[2] = gSef_SefCoef[gTeban_me][JOBAN][2];	/* μͳ */
			break;
		case CHUBAN:
			coef[0] = gSef_SefCoef[gTeban_me][CHUBAN][0];	/* Ȥ */
			coef[1] = gSef_SefCoef[gTeban_me][CHUBAN][1];	/*  */
			coef[2] = gSef_SefCoef[gTeban_me][CHUBAN][2];	/* μͳ */
			break;
		case SHUBAN:
			coef[0] = gSef_SefCoef[gTeban_me][SHUBAN][0];	/* Ȥ */
			coef[1] = gSef_SefCoef[gTeban_me][SHUBAN][1];	/*  */
			coef[2] = gSef_SefCoef[gTeban_me][SHUBAN][2];	/* μͳ */
			break;
		default: break;
	}

	/* Ȥߤɾ result 0 */
	result[0] = 0;	/*  */
	if( coef[0]!=0 ) {	/* 0λϷ׻ʤ */
		int x,y,r;
		/* ﷿ */
		for( i=0;i<KOMA_NUM;i++ ) {
			if( kz(i)<HAND && kc(i)==gTeban_me ) {
				x = MeasureX( gSef_Kakoi[gTeban_me][gSef_Senkei[gTeban_me]][i].zahyo, kz(i) );
				y = MeasureY( gSef_Kakoi[gTeban_me][gSef_Senkei[gTeban_me]][i].zahyo, kz(i) );
				r = 2*x + y;
				result[0] += (coef[0] *
					gSef_Kakoi[gTeban_me][gSef_Senkei[gTeban_me]][i].value / (r+1));
			}
		}
	}

	/* ɾ result 1 */
	result[1] = 0;	/*  */
	for( i=0;i<KOMA_NUM;i++ ) {
		if( kc(i)==gTeban_me ) {	/* + Фλ */
			result[1] += (coef[1] * gSef_PointKoma[gTeban_me][kt(i)]);
		}
	}

	/* ̤ɾ result 2 */
	result[2] = 0;
	for( i=0; i<KOMA_NUM; i++ ) {
	if( kz(i)<HAND && kc(i)==gTeban_me ) {
	switch( kt(i) ) {
		int x,y,r;

		case KING:	/*  */
			/* ̤ϲʤüˤۤup */
			x = MeasureX( 40, kz(i) );
			y = MeasureY( 40, kz(i) );
			result[2] += ( coef[2] * (x+y*2) );
			break;

		case SILVER:	/*   */
			/* +ͳ */
			for( j=0;j<BAN_NUM;j++ ) {
				if( Movable( kz(i), j, fld, kom) )
					result[2]+=coef[2];
			}
			/* θ */
			for( r=0;r<KOMA_NUM;r++ ) {
				if( kz(r)<HAND && kc(r)==gTeban_me && kt(r)==PAWN ) {
					if( MeasureX(kz(r),kz(i))==0 && Movable(kz(i),kz(r),fld,kom) )
						result[2] += (coef[2] * gSef_PointKoma[gTeban_me][kt(i)]);
				}
			}

		case GOLD:	/*  */
			/* ⡢ϸ¿ۤup */
			result[2] += ( coef[2] * Kiki(fld,kom,kz(i),gTeban_me) );
			break;

		case BISHOP:	/*  */
		case ReBISHOP:
			/* +ͳ */
			for( j=0;j<BAN_NUM;j++ ) {
				if( Movable( kz(i), j, fld, kom) )
					result[2]+=coef[2];
			}
			/* - */
			for( r=0;r<KOMA_NUM && kz(r)<HAND && kc(r)==gTeban_me;r++ ) {
				if( MeasureX(kz(r),kz(i))==0 ) 
					result[2] -= (coef[2] * gSef_PointKoma[gTeban_me][PAWN]);
			}
			break;

		case ROOK:	/*  */
		case ReROOK:
			/* +ͳ */
			for( j=0;j<BAN_NUM;j++ ) {
				if( Movable( kz(i), j, fld, kom) )
					result[2]+=coef[2];
			}
			break;

		case KNIGHT:
		case ReKNIGHT:
		case LANCE:
		case ReLANCE:
		case PAWN:
		case RePAWN:
			if( gSituation<SHUBAN ) break;
			x = MeasureX( 40, kz(i) );
			y = MeasureY( 40, kz(i) );
			if( (x+y) < BAN_YOKO/2 ) break;
			x = MeasureX( 40, kz(king_you(gTeban_me)) );
			y = MeasureY( 40, kz(king_you(gTeban_me)) );
			result[2] -= ( gSef_PointKoma[gTeban_me][kt(i)] * (x+y) );
			break;

		default: break;
	}	/* end of switch */
	}	/* end of if */
	}	/* end of for */

	/* ɾͤη׻ */
	for( i=0;i<FACTOR;i++ )
		sum += result[i];	/* Ǥû */
	if( gSef_RandMax[gTeban_me] )
	  sum += rand() % gSef_RandMax[gTeban_me];	/* ä */

	/* ̤ͤ줿̤ͤäǹ */
	if( kz(king_me(gTeban_me)) >= HAND ) sum=SCORE_MIN;
	if( kz(king_you(gTeban_me)) >= HAND ) sum=SCORE_MAX;
	/*  */
	TimerUpdate( gTeban_me );

	return sum;
}


/* Tef(fld,kom,prev,next)
 * ɾؿ(Tesuji Evaluation Function)
 * in:	fld		۶
 *		kom		۶
 * 		prev	κɸ
 *		next	ưκɸ
 * out:			׻
 */
long
Tef(int *fld, KomaDef *kom, int prev, int next)
{
	long result[VIRFACTOR];
	int coef[VIRFACTOR];
	int i,rate,prekoma,nexkoma,control;
	long sum = 0;

	control = fld_control(prev);	/*  */
	/* ۶  prekoma:ư,  nexkoma:ͤ */
	prekoma = fld[prev];
	fld[prev] = NONE;	/* Ū˶ */
	nexkoma = fld[next];
	fld[next] = prekoma;/* Ū˶֤ */

	/*  */
	switch( gSituation ) {
		case JOBAN:
			coef[0] = gSef_TefCoef[gTeban_me][JOBAN][0];	/* Ȥ */
			coef[1] = gSef_TefCoef[gTeban_me][JOBAN][1];	/*  */
			coef[2] = gSef_TefCoef[gTeban_me][JOBAN][2];	/* ɾ */
			break;
		case CHUBAN:
			coef[0] = gSef_TefCoef[gTeban_me][CHUBAN][0];	/* Ȥ */
			coef[1] = gSef_TefCoef[gTeban_me][CHUBAN][1];	/*  */
			coef[2] = gSef_TefCoef[gTeban_me][CHUBAN][2];	/* ɾ */
			break;
		case SHUBAN:
			coef[0] = gSef_TefCoef[gTeban_me][SHUBAN][0];	/* Ȥ */
			coef[1] = gSef_TefCoef[gTeban_me][SHUBAN][1];	/*  */
			coef[2] = gSef_TefCoef[gTeban_me][SHUBAN][2];	/* ɾ */
			break;
		default: break;
	}

	/* Ȥߤɾ result 0 */
	result[0] = 0;
	if( control==gTeban_me && coef[0]!=0 ) {	/* ʬλΤ߷׻ */
		int x, y;
		x = MeasureX( gSef_Kakoi[gTeban_me][gSef_Senkei[gTeban_me]][prekoma].zahyo, next );
		y = MeasureY( gSef_Kakoi[gTeban_me][gSef_Senkei[gTeban_me]][prekoma].zahyo, next );
		rate = 2*x + y;
		result[0] += (coef[0] *
			gSef_Kakoi[gTeban_me][gSef_Senkei[gTeban_me]][prekoma].value / (rate+1));
	}

	/*  result 1 */
	result[1] = 0;
	if( nexkoma!=NONE ) {	/* Ũζͤ */
		/* + ͤäβ */
		result[1] += (coef[1] * gSef_PointKoma[gTeban_me][kt(nexkoma)]);
		/* + ǳͤä */
		result[1] += (coef[1] * (gSef_PointKoma[gTeban_me][KING] - gSef_PointKoma[gTeban_me][kt(prekoma)]) );
	}
	if( gSituation>JOBAN ) {
		rate = Kiki(fld,kom,next,gTeban_me);	/* +Τؤΰư */
		result[1] += (coef[1] * gSef_PointKoma[gTeban_me][kt(prekoma)] /5 * rate );
	}
	for( i=0;i<KOMA_NUM;i++ ) {
		if( kz(i)<HAND && kc(i)!=control ) {
			if( Movable( next, kz(i), fld, kom) ) {		/* +ͤ */
				rate = Kiki(fld,kom,kz(i),gTeban_you);	/* ο */
				result[1] += (coef[1] * gSef_PointKoma[gTeban_me][kt(i)] /(rate+1));
			}
			if( Movable( kz(i), prev, fld, kom) ) {		/* +ƨ */
				result[1] += (coef[1] * gSef_PointKoma[gTeban_me][kt(prekoma)]);
			}
			if( Movable( kz(i), next, fld, kom) ) {		/* -ͤ */
				rate = Kiki(fld,kom,next,gTeban_me);	/* ο */
				result[1] -= (coef[1] * gSef_PointKoma[gTeban_me][kt(prekoma)] /(rate+1));
			}
		}
	}
	if( prev>=HAND ) {	/* Ǥǥʤ-MAX */
		if( Kiki(fld,kom,next,gTeban_you)>0 &&
			Kiki(fld,kom,next,gTeban_me)==0 ) result[1] = SCORE_MIN;
	}

	/* ɾ result 2 */
	result[2] = 0;
	switch( kt(prekoma) ) {
		int x,y;

		case KING:	/*  */
			/* ü */
			x = MeasureX( 40, next );
			y = MeasureY( 40, next );
			result[2] += ( coef[2] * (x+y) );
			break;

		case BISHOP:	/*  */
		case ReBISHOP:
			/* +ͳ */
			for( i=0;i<BAN_NUM;i++ ) {
				if( Movable( next, i, fld, kom) )
					result[2] += coef[2] * (MeasureX(next,i)==0? 2: 1);
			}
			break;

		case ROOK:	/*  */
		case ReROOK:
			/* +ͳ */
			for( i=0;i<BAN_NUM;i++ ) {
				if( Movable( next, i, fld, kom) )
					result[2]+=coef[2];
			}
			break;

		case PAWN:	/*  */
			/* 򴹤 */
			if( kc(1)==gTeban_me && MeasureX(next,kz(1))==0 )
				result[2] += (coef[2] * gSef_PointKoma[gTeban_me][kt(prekoma)]);
			if( kc(21)==gTeban_me && MeasureX(next,kz(21))==0 )
				result[2] += (coef[2] * gSef_PointKoma[gTeban_me][kt(prekoma)]);
			/* Υ줿ʤ̥ӥ */
//			if( gSituation!=JOBAN ) {
				if( MeasureX(kz(king_me(gTeban_me)),prev) > BAN_YOKO/2 )
					result[2] += (coef[2] * (rand() % gSef_PointKoma[gTeban_me][PAWN]) );
//			}
			break;

		default: break;
	}

	/* ᤹ */
	fld[next] = nexkoma;
	fld[prev] = prekoma;

	/* ɾͤ */
	for( i=0;i<VIRFACTOR;i++ )
		sum += result[i];

	return sum;	/* ХХ */
}


/* MeasureX(zahyo1,zahyo2)
 * εΥX)¬
 * in:	zahyo1, zahyo2	׾κɸ
 * out:					XεΥ
 */
static int
MeasureX(int zahyo1, int zahyo2)
{
	int x1 = zahyo1%BAN_YOKO;
	int x2 = zahyo2%BAN_YOKO;
	if( x1>=x2 )
		return (x1-x2);
	else
		return (x2-x1);
}


/* MeasureY(zahyo1,zahyo2)
 * εΥY)¬
 * in:	zahyo1, zahyo2	׾κɸ
 * out:					YεΥ
 */
static int
MeasureY(int zahyo1, int zahyo2)
{
	int y1 = zahyo1/BAN_YOKO;
	int y2 = zahyo2/BAN_YOKO;
	if( y1>=y2 )
		return (y1-y2);
	else
		return (y2-y1);
}


/* Kiki(fld,kom,zahyo,control)
 * ۶̤ˤθο
 * in:	fld		۶
 *		kom		۶
 *		zahyo	Ĵ٤ɸ
 *		control	ɤ¦θĴ٤Τ
 * out:			ο
 */
static int
Kiki(int *fld, KomaDef *kom, int zahyo, int control)
{
	int i, dekoma, ret;

	dekoma = fld[zahyo];
	fld[zahyo] = NONE;
	ret = 0;
	for( i=0;i<KOMA_NUM;i++ ) {
		if( kz(i)<HAND && kc(i)==control ) {
			if( Movable(kz(i),zahyo,fld,kom) ) ret++;
		}
	}
	fld[zahyo] = dekoma;
	return ret;
}
