/***********************************************************
 * Utility.c
 * в۽
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: Utility.c,v 1.1 2000/07/26 12:39:11 satofumi Exp $
 **********************************************************/
#define _UTILITY_C_

#include "global.h"
#include "core.h"
#include "Utility.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


extern int *fld;
extern KomaDef *kom;
/*------------------------------------------------------------algovir.c */
/* VirKomaMove(prev,next,control)
 * ۶̤ˤΰư
 * in:	prev		κɸ
 *		next		ưκɸ
 *		control		SENTE or GOTE
 * out: TRUE		ưä
 *		FALSE		ưϤΤޤ
 */
boolean
VirKomaMove(int prev, int next, int control)
{
	int i;
	int flag = FALSE;

	/* ưζ𤬤롪 */
	if( fld[next] != NONE ) {
		if( control==SENTE ) {
			fld_control(next) = SENTE;	/* ۸ */
			for(i=0; fld[SENTE_STOCK+i]!=NONE && i<STOCK_MAX; i++)
				;
			fld[SENTE_STOCK + i] = fld[next];	/* ȥå */
			fld_zahyo(next) = SENTE_STOCK+i;	/* ɸ¸ */
		} else {
			fld_control(next) = GOTE;	/* ۸ */
			for(i=0; fld[GOTE_STOCK+i]!=NONE && i<STOCK_MAX; i++)
				;
			fld[GOTE_STOCK + i] = fld[next];	/* ȥå */
			fld_zahyo(next) = GOTE_STOCK+i;	/* ɸ¸ */
		}
	}
	/* Ũؤ */
	if( prev<HAND ) {	/* ǤǤϤʤ */
		if( 2<=fld_type(prev) && fld_type(prev)<=7 ) {
			if( ( (prev>53 || next>53) && control==GOTE ) ||
				( (prev<27 || next<27) && control==SENTE ) ) {
				fld_type(prev) += 6;	/* ѿȡ */
				flag = TRUE;		/* ե饰ΩƤ */
			}
		}
	}
	/* ư */
	fld[next] = fld[prev];	/* ư˥ԡ */
	fld_zahyo(prev) = next;	/* ɸ¸ */
	fld[prev]	= NONE;		/* ξˤ϶Ϥʤ */

	return flag;
}


/* VirKomaDisMove(prev,next,control,dekoma,flag)
 * ۶̤ˤΰư
 * in:	prev		κɸ
 *		next		ưκɸ
 *		control		SENTE or GOTE
 *		dekoma		κɸˤä
 *		flag		TRUE:ä  FALSE:äƤʤ
 */
void
VirKomaDisMove(int prev, int next, int control, int dekoma, int flag)
{
	int i;

	fld[prev] = fld[next];
	fld_zahyo(next) = prev;
	fld[next] = NONE;	/* õ */
	if( flag ) fld_type(prev) -= 6;		/* äƤ᤹ */
	if( dekoma!=NONE ) {	/* ͤäƤʤ */
		fld[next] = dekoma;	/*  */
		kom[dekoma].zahyo 	= next;	/* ɸ */
		if( control==SENTE ) {
			kom[dekoma].control = GOTE;	/* ۤ */
			for(i=0; fld[SENTE_STOCK+i]!=dekoma && i<STOCK_MAX; i++)
				;
			fld[SENTE_STOCK + i] = NONE;/* ȥåõ */
		} else {
			kom[dekoma].control = SENTE;/* ۤ */
			for(i=0; fld[GOTE_STOCK+i]!=dekoma && i<STOCK_MAX; i++)
				;
			fld[GOTE_STOCK + i] = NONE;	/* ȥåõ */
		}
	}

}


/* TsjAlloc(n)
 * ѤΥƤƥɥ쥹֤
 */
int *
TsjAlloc(int n)
{
	int *p;
	//	p=(TesujiDef *)calloc( 1, sizeof(TesujiDef) * n );
	p=(int *)malloc( sizeof(int) * n );
	if( p == NULL ) {
		DispError( "out of memory" );
		exit(-1);
	}
	return p;
}


/* TsjFree(n)
 * ѤΥ
 */
void
TsjFree(int *p, int *q)
{
	free( p );
	p = NULL;
	free( q );
	q = NULL;
}


/* TsjCheck(prev,next)
 * ڤΥå
 * out: TRUE  
 *		FALSE ְä
 */
boolean
TsjCheck(int prev, int next)
{
    if( prev<0 || FIELD_MAX<prev ) return FALSE;
    if( next<0 || BAN_NUM<=next ) return FALSE;
	if( prev==next ) return FALSE;
    return TRUE;
}


/* TsjCopy(vtsj1,vtsj2)
 * ڤΥԡ
 */
void
TsjCopy(TesujiDef *vtsj1, TesujiDef *vtsj2)
{
  //	memcpy( vtsj1, vtsj2, sizeof(TesujiDef) );
  vtsj1->prev = vtsj2->prev;
  vtsj1->next = vtsj2->next;
  vtsj1->value = vtsj2->value;
}


/* TesujiSort(vtsj, n)
 * ڤΥ
 * in:	vtsj	ڹ¤
 *		n		
 */
void
TesujiSort(TesujiDef *vtsj, int n)
{
    // 륽
	int h,i,j;
	TesujiDef t;	// Ѵ

	for( h=1;h<n/9;h=h*3+1 )	// h-
		;
	for( ;h>0;h/=3 ) {
		for( i=h;i<n;i++ ) {	// ڤο¹
			j = i;
			while( j>=h && (vtsj+j-h)->value < (vtsj+j)->value ) {
				TsjCopy(       &t, vtsj+j   );
				TsjCopy( vtsj+j  , vtsj+j-h );
				TsjCopy( vtsj+j-h,       &t );
				j -= h;
			}
		}
	}
}
