/***********************************************************
 * mglArch.c
 * Хƥ¸ؿ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: mglArch.c,v 1.2 2000/08/08 14:27:50 satofumi Exp satofumi $
 **********************************************************/
#define _MGLARCH_C_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "../core/global.h"
#include "system.h"
#include "mglArch.h"
#include "mglConsl.h"
#include "mglFile.h"

#ifdef SMG_MGL1
#include <mgl.h>	/* mgl1 */
#else
#include <mgl2.h>	/* mgl2 */
#endif

#ifdef DJGPP
#include <bios.h>
#else
#ifndef WIN32
#include <errno.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#endif
#endif


/*  */
#define SMG_COM1	0

/*------------------------------------------------------------mglArch.c */
/* ComSend()
 * com ݡȤ(DOS only)
 * in:	str		ʸ
 */
void
ComSend(unsigned char *str)
{
#ifdef DJGPP
	int length,i;
	unsigned char status[30];

	sprintf( status, " %s", str );
	DispStatus( status );	/* ɽ */

	length = strlen( str );
	str[length] = 0x0A;		/*  0x0A դ */

	/* 1200 baud, no parity, one stop, 8 bits */
	_bios_serialcom(_COM_INIT, SMG_COM1,
					_COM_1200|_COM_NOPARITY|_COM_STOP1|_COM_CHR8);
	for(i=0; i<length+1; i++)
		_bios_serialcom(_COM_SEND, SMG_COM1, str[i]);	/*  */
#endif
}


/* ComReceive()
 * com ݡȤ(DOS only)
 * in:		ʸ򤳤
 */
boolean
ComReceive(unsigned char *buf)
{
#ifdef DJGPP
	unsigned char status[30];
	short ret,ret_0xff;
	int mgk, i;

	/* 1200 baud, no parity, one stop, 8 bits */
	_bios_serialcom(_COM_INIT, SMG_COM1,
					_COM_1200|_COM_NOPARITY|_COM_STOP1|_COM_CHR8);
	i = 0;
	//DispStatus( "..." );
	while( ret_0xff!=0x0A || i<4 ) {
		ret = _bios_serialcom(_COM_RECEIVE, SMG_COM1, NULL);/* ! */
		ret_0xff = ret & 0xff;
		/* ̣ΤʸỌ̇̄Τʤʸ */
		if( isalnum(ret_0xff) || ret_0xff==0x0A ) {
			i++;
		} else {
		  //TimerUpdate( teban );	/*  */
			mgk = mgl_get_key(SMG_NOWAIT);	/* Ƚ */
			if( mgk == SMG_ESC ) {
			  //ComSend( "%CHUDAN" );
				return FALSE;
			}
		}
		buf[i] = ret_0xff;
	}
	buf[i+1] = NULL;	/*  NULL դ */

	sprintf( status, " %s", buf );
	DispStatus( status );	/* ɽ */
	return TRUE;
#else
	return FALSE;
#endif
}


/* SetFileName()
 * ե̾򥻥åȤ
 */
boolean
SetFileName(void)
{
#if defined(DJGPP) || defined(WIN32)
    sprintf(gIni_file_sente, "%s", INI_FILE_SENTE);
    sprintf(gIni_file_gote , "%s", INI_FILE_GOTE );
    sprintf(gCsa_file      , "%s", CSA_FILE      );
    return TRUE;
#else
    char path[256];
    struct passwd *pwd;
    struct stat sb;

    pwd = getpwuid(getuid());
    if (!pwd){
	  fprintf(stderr,"Error: getpwuid\n");
	  return FALSE;
    }

    sprintf(path, "%s/.shogimg", pwd->pw_dir);
    if (stat(path, &sb) < 0){
	if (errno == ENOENT){
	  mkdir(path, 0700);
	}else{
	  fprintf(stderr,"Error: mkdir\n");
	  return FALSE;
	}
    }else if (!S_ISDIR(sb.st_mode)){
	  fprintf(stderr,"Error: $HOME/.shogimg exists.\n");
	  return FALSE;
    }

    sprintf(gIni_file_sente, "%s/.shogimg/%s", pwd->pw_dir, INI_FILE_SENTE);
    sprintf(gIni_file_gote , "%s/.shogimg/%s", pwd->pw_dir, INI_FILE_GOTE );
    sprintf(gCsa_file      , "%s/.shogimg/%s", pwd->pw_dir, CSA_FILE      );
    return TRUE;
#endif
}
