/***********************************************************
 * mglDisp.c
 * ɽؿ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: mglDisp.c,v 1.3 2000/08/08 14:27:50 satofumi Exp satofumi $
 **********************************************************/
#define _MGLDISP_C_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../core/global.h"
#include "../core/Main.h"
#include "system.h"
#include "mglMain.h"
#include "mglDisp.h"
#include "mglConsl.h"
#include "mglGame.h"
#include "mglTime.h"

#ifdef SMG_MGL1
#include <mgl.h>	/* mgl1 */
#else
#include <mgl2.h>	/* mgl2 */
#include <mglcol.h>	/* for color */
#include "komadata.h"	/* ǡ */
static struct screen *koma_screen[TEBAN_NUM][KOMA_TYPE_MAX];
#endif


/* ؿ */
/* ǡ */
static unsigned char *koma_sente[KOMA_TYPE_MAX] = {
	"",/* 0, KING */
	"",/* 1, GOLD */
	"",/* 2, BISHOP */
	"",/* 3, ROOK */
	"",/* 4, SILVER */
	"",/* 5, KNIGHT */
	"",/* 6, LANCE */
	"",/* 7, PAWN */
	"ζ",/* 8,ζ ReBISHOP */
	"",/* 9, ReROOK */
	"",/* 10,() ReSILVER */
	"\0",/* 11,() ReKNIGHT (for shift-jis) */
	"",/* 12,() ReLANCE */
	"",/* 13, RePAWN */
};

static unsigned char *koma_gote[KOMA_TYPE_MAX] = {
	"",/* 0, KING */
	"",/* 1, GOLD */
	"",/* 2, BISHOP */
	"",/* 3, ROOK */
	"",/* 4, SILVER */
	"",/* 5, KNIGHT */
	"",/* 6, LANCE */
	"",/* 7, PAWN */
	"ζ",/* 8,ζ ReBISHOP */
	"",/* 9, ReROOK */
	"",/* 10,() ReSILVER */
	"\0",/* 11,() ReKNIGHT (for shift-jis) */
	"",/* 12,() ReLANCE */
	"",/* 13, RePAWN */
};

static unsigned char *num_char[2][BAN_YOKO] = {
	{"","","","","","","","",""},
	{"","","","","","ϻ","","Ȭ",""},
};

/* ɽ(ɸ640x240) */
#define FONT_X_SIZE		8
#define FONT_Y_SIZE		(FONT_X_SIZE*2)
#define STOCK_X_SIZE	16
#define STOCK_Y_SIZE	24
#define KOMA_SIZE		20
#define NUM_SIZE		12
#define COPY_SIZE		12
#define TIME_SIZE		16
#define KIFU_SIZE		16
#define STATUS_SIZE		12
#define STOCK_YOKO		10	/* Υޥܤο */
#define STOCK_TATE		4

/* ɽ(⡼480x240) */
#define SMALL_FONT_X_SIZE	8
#define SMALL_FONT_Y_SIZE	(FONT_X_SIZE*2)
#define SMALL_STOCK_X_SIZE	16
#define SMALL_STOCK_Y_SIZE	20
#define SMALL_KOMA_SIZE		20
#define SMALL_NUM_SIZE		12
#define SMALL_COPY_SIZE		12
#define SMALL_TIME_SIZE		12
#define SMALL_KIFU_SIZE		12
#define SMALL_STATUS_SIZE	12
#define SMALL_STOCK_YOKO	7	/* Υޥܤο */
#define SMALL_STOCK_TATE	6


static void KomaDraw(int fz, int koma_type, int control);
static void StockDraw(int fx, int fy, int koma_num, int control);
static void StockDrawPalm(void);

/*------------------------------------------------------------mglDisp.c */
/* SetDisplayLayout(screen_width,screen_height)
 * ̤礭˹碌ƥ쥤Ȥ
 */
void
SetDisplayLayout(int screen_width, int screen_height)
{
	/* ƼեȤ */
    if ( screen_width > 560 ) {
	  gFontSize.x = FONT_X_SIZE;  /* ̾ʸ */
	  gFontSize.y = FONT_Y_SIZE;
	  gFontSize.stock_x = STOCK_X_SIZE;	/* ζ */
	  gFontSize.stock_y = STOCK_Y_SIZE;
	  gFontSize.koma = KOMA_SIZE;	/* ׾ζ */
	  gFontSize.num = NUM_SIZE;		/* ֹ */
	  gFontSize.copy = COPY_SIZE;	/* copyrightʸ */
	  gFontSize.time = TIME_SIZE;	/* ׹ͻ */
	  gFontSize.kifu = KIFU_SIZE;	/*  */
	  gFontSize.status = STATUS_SIZE;	/* ơ */
	  gStockYoko = STOCK_YOKO;	/* Υޥܤο */
	  gStockTate = STOCK_TATE;
	} else {
	  gFontSize.x = SMALL_FONT_X_SIZE;  /* ׾ζ */
	  gFontSize.y = SMALL_FONT_Y_SIZE;
	  gFontSize.stock_x = SMALL_STOCK_X_SIZE;	/* ζ */
	  gFontSize.stock_y = SMALL_STOCK_Y_SIZE;
	  gFontSize.koma = SMALL_KOMA_SIZE;	/* ׾ζ */
	  gFontSize.num = SMALL_NUM_SIZE;		/* ֹ */
	  gFontSize.copy = SMALL_COPY_SIZE;	/* copyrightʸ */
	  gFontSize.time = SMALL_TIME_SIZE;	/* ׹ͻ */
	  gFontSize.kifu = SMALL_KIFU_SIZE;	/*  */
	  gFontSize.status = SMALL_STATUS_SIZE;	/* ơ */
	  gStockYoko = SMALL_STOCK_YOKO;	/* Υޥܤο */
	  gStockTate = SMALL_STOCK_TATE;
	}
	/* פ */
    if ( screen_width > screen_height ) {
	  gBan.size = (screen_height-gFontSize.num*2.5)/BAN_TATE;
	} else {
	  gBan.size = (screen_width-gFontSize.num*4.25)/BAN_YOKO;
	}
	gBan.width  = gBan.size * BAN_YOKO;
	gBan.height = gBan.size * BAN_TATE;
	gBan.x      = (screen_width - gBan.width)/2;
	gBan.y      = (screen_height - gBan.height)/2;
}


/* ShogibanDraw(screen_width,screen_height)
 * פ
 */
void
ShogibanDraw(int screen_width, int screen_height)
{
  int i;
  /*  */
  gColor.ban = GRAY1;
  gColor.bg = WHITE;
  gColor.none = WHITE;
  gColor.before_move = WHITE;
#ifndef SMG_MGL1
  if ( gOptColor ) {
	gColor.ban = packMC(1,7,7);
	gColor.bg = packMC(1,7,12);
	gColor.none = packMC(1,7,7);
	gColor.before_move = packMC(1,7,15);
  }
#endif
  mgl_set_color( gColor.bg );
  mgl_fill_rect(0,0,screen_width,screen_height);
  mgl_set_color( gColor.ban );
  mgl_fill_rect(gBan.x-gFontSize.num, gBan.y-gFontSize.num,
				gBan.width+gFontSize.num*2, gBan.height+gFontSize.num*2);
  /* 饤 */
  mgl_set_color( BLACK );
  for( i=0; i<10; i++ )
	mgl_draw_line(gBan.x, 	       	 gBan.y+gBan.size*i,
				  gBan.x+gBan.width, gBan.y+gBan.size*i);
  for( i=0; i<10; i++ )
	mgl_draw_line(gBan.x+gBan.size*i, gBan.y,
				  gBan.x+gBan.size*i, gBan.y+gBan.height);
  /* ֹ */
  mgl_set_font( gFontSize.num, FA_NORMAL );	/* եѹ */
  for( i=0;i<BAN_YOKO;i++ )
	mgl_draw_string( gBan.x+(BAN_YOKO-i-1)*gBan.size+(gBan.size-gFontSize.num)/2,
					 gBan.y - gFontSize.num,
					 num_char[0][i],
					 DIR_NORTH
					 );
  for( i=0;i<BAN_TATE;i++ )
	mgl_draw_string( gBan.x + BAN_YOKO*gBan.size,
					 gBan.y + i*gBan.size + (gBan.size-gFontSize.num)/2,
					 num_char[1][i],
					 DIR_NORTH
					 );
  mgl_set_font( gFontSize.y, FA_NORMAL );	/* ե᤹ */
}


/* ReDraw()
 * ¤٤
 * in:	timer_draw	0:ޡʤ1:ޡ褢
 */
void
ReDraw(boolean timer_draw)
{
	int i,j;

	/* եɤ */
	mgl_set_font( gFontSize.y, FA_NORMAL );
	for (i=0; i<BAN_NUM; i++) {
		if( gField[i]==NONE )
			KomaDraw( i, NONE, NONE );
		else
			KomaDraw(i, gKoma[gField[i]].type, gKoma[gField[i]].control);
	}
	/*  */
	if ( gWakuFlag[1] && gWakuFlag[2] ) {
	  GraphicWaku( gWaku[1].x, gWaku[1].y,
				   gWaku[1].width, gWaku[1].height, gColor.ban );
	  GraphicWaku( gWaku[2].x, gWaku[2].y,
				   gWaku[2].width, gWaku[2].height, gColor.ban );
	  mgl_set_color( BLACK );
	  mgl_set_font( gFontSize.stock_x, FA_NORMAL );
	  for (j=0; j<gStockTate; j++) {
		for (i=0; i<gStockYoko; i++) {
		  StockDraw( i, j, gField[ SENTE_STOCK + j*gStockYoko+i ], SENTE);
		  StockDraw( gStockYoko-i-1, gStockTate-j-1,
					 gField[ GOTE_STOCK + j*gStockYoko+i ], GOTE);
		}
	  }
	} else {
	  StockDrawPalm();	/* for PalmSizePC */
	}
	/* ޡκ */
	if( timer_draw ) {
		TimerSet( SENTE );
		TimerSet( GOTE );
	}
	mgl_refresh();
}


/* KomaDraw(fz,koma_type,control)
 * 
 * fz 0-80	פκɸ
 * koma_type	Υ
 * control  SENTE	
 *       	GOTE	
 */
static void
KomaDraw(int fz, int koma_type, int control)
{
	int fx,fy,x,y;

	fx = zahyo_x(fz);
	fy = zahyo_y(fz);
	x = (fx * gBan.size + gBan.x);
	y = (fy * gBan.size + gBan.y);
	/* ޤäơ */
	mgl_set_color( gColor.none );
	if( fz==gMove_next ) mgl_set_color( gColor.before_move );
	mgl_fill_rect( x+1, y+1, gBan.size-1, gBan.size-1 );
	mgl_set_color( BLACK );
	if( control==NONE ) return;	/* ξϽ */
#ifndef SMG_MGL1
	/* եå */
	x += (gBan.size-koma_screen[control][koma_type]->width)/2;
	y += (gBan.size-koma_screen[control][koma_type]->height)/2;
	if ( !gOptText ) {
	  mgl_bitblt( NULL, x+1, y+1,
				  koma_screen[control][koma_type], 0, 0,
				  koma_screen[control][koma_type]->width,
				  koma_screen[control][koma_type]->height,
				  BLT_MASKING + WHITE
				  );
	  return;
	}
#endif
	/* ƥȶ */
	x += (gBan.size-gFontSize.x*2)/2;
	y += (gBan.size-gFontSize.y)/2;
	if( fz==gMove_next ) mgl_set_font( gFontSize.y, FA_BOLD );
	switch( control ) {
	    int code;
		case SENTE :	/* ξ */
			code = (koma_sente[koma_type][0] << 8) & 0xffff;
			code |= koma_sente[koma_type][1] & 0xff;
			mgl_draw_font( x, y, code, DIR_NORTH );
			break;

		case GOTE :	/* ξ */
			code = (koma_gote[koma_type][0] << 8) & 0xffff;
			code |= koma_gote[koma_type][1] & 0xff;
			/* MGL1  MGL2 Ǻɸλ꤬㤦 */
			#ifdef SMG_MGL1
				mgl_draw_font( x, y, code, DIR_SOUTH );
			#else
				x += gFontSize.x*2;
				y += gFontSize.y;
				mgl_draw_font( x, y, code, DIR_SOUTH );
			#endif
			break;

		default :
			break;
	}
	if( fz==gMove_next ) mgl_set_font( gFontSize.y, FA_NORMAL );
}


/* StockDraw(fx,fy,koma_num,control)
 * 
 * fx 0-9	ɸ
 * fy 0-3	ɸ
 * koma_num	ֹ
 * control  SENTE	
 *       	GOTE	
 */
static void
StockDraw(int fx, int fy, int koma_num, int control)
{
    int x,y,code;

	if ( koma_num==NONE ) return;	/* ̵Ͻ */
#ifndef SMG_MGL1
	/* եå */
	if ( !gOptText ) {
	  x = fx * (gWaku[control+1].width-gFontSize.koma+gFontSize.stock_x)/gStockYoko
		+ gWaku[control+1].x;
	  y = fy * (gWaku[control+1].height/gStockTate) + gWaku[control+1].y
		+ (gFontSize.stock_y - gFontSize.koma)/2;
	  mgl_bitblt( NULL, x, y,
				  koma_screen[control][gKoma[koma_num].type], 0, 0,
				  koma_screen[control][gKoma[koma_num].type]->width,
				  koma_screen[control][gKoma[koma_num].type]->height,
				  BLT_MASKING + WHITE
				  );
	  return;
	}
#endif
	/* ƥȶ */
	if ( control==SENTE ) {	/* ¦ */
	  x = fx * gFontSize.stock_x + gWaku[1].x;
	  y = fy * gFontSize.stock_y + gWaku[1].y
		+ (gFontSize.stock_y - gFontSize.stock_x)/2;
	} else {	/* ¦ */
	  /* MGL1  MGL2 Ǻɸλ꤬㤦 */
      #ifdef SMG_MGL1
	    x = fx * gFontSize.stock_x + gWaku[2].x - 1;
	    y = fy * gFontSize.stock_y + gWaku[2].y - 1 + 4;
      #else
	    x = (fx+1) * gFontSize.stock_x + gWaku[2].x - 1;
	    y = (fy+1) * gFontSize.stock_y + gWaku[2].y - 1
		  - (gFontSize.stock_y - gFontSize.stock_x)/2;
      #endif
	}
	switch( control ) {
		case SENTE :	/* ξ */
			code = (koma_sente[gKoma[koma_num].type][0] << 8) & 0xffff;
			code |= koma_sente[gKoma[koma_num].type][1] & 0xff;
			mgl_draw_font( x, y, code, DIR_NORTH );
			break;

		case GOTE :	/* ξ */
			code = (koma_gote[gKoma[koma_num].type][0] << 8) & 0xffff;
			code |= koma_gote[gKoma[koma_num].type][1] & 0xff;
			mgl_draw_font( x, y, code, DIR_SOUTH );
			break;

		default :
			break;
	}
}


/* StockDrawPalm(koma_num,control)
 * ( for Palm )
 * SENTE: 0, GOTE: 1
 */
static void
StockDrawPalm(void)
{
	int x,y,size,i;
	int code;
	int koma_sum[TEBAN_NUM][KOMA_TYPE_MAX];
	char str[256];

	/*  */
	for (i=0; i<KOMA_TYPE_MAX; i++) {
	  koma_sum[SENTE][i]=0;
	  koma_sum[GOTE][i]=0;
	}
	/* count */
    for (i=0; i<STOCK_MAX; i++) {
	  if (gField[SENTE_STOCK+i]!=NONE)
		koma_sum[SENTE][ gKoma[gField[SENTE_STOCK+i]].type ]++;
	  if (gField[GOTE_STOCK+i]!=NONE)
		koma_sum[GOTE][ gKoma[gField[GOTE_STOCK+i]].type ]++;
	}
	/*  */
	size = gFontSize.stock_y;
	mgl_set_color( WHITE );
	mgl_fill_rect( gBan.x + gBan.width + gFontSize.num,
				   gBan.y + gBan.height - (size*2 * PAWN),
				   size,
				   size*2 * PAWN
				   );
	mgl_fill_rect( gBan.x - gFontSize.num - size,
				   gBan.y,
				   size,
				   size*2 * PAWN
				   );
	mgl_set_color( BLACK );
	mgl_set_font( size, FA_NORMAL );
	/* ¦ */
 	for (i=PAWN; i>KING; i--) {
	  x = gBan.x + gBan.width + gFontSize.num;
	  y = gBan.y + gBan.height - (size*2*(PAWN-i+1));
	  code = (koma_sente[i][0] << 8) & 0xffff;
	  code |= koma_sente[i][1] & 0xff;
	  mgl_draw_font( x, y, code, DIR_NORTH );
	  y += size;
	  sprintf( str, "%2d", koma_sum[SENTE][i] );
	  mgl_draw_string( x, y, str, DIR_NORTH );
	}
	/* ¦ */
	for (i=PAWN; i>KING; i--) {
	  x = gBan.x - gFontSize.num;
	  y = gBan.y + size*2 * (PAWN-i+1);
	  code = (koma_gote[i][0] << 8) & 0xffff;
	  code |= koma_gote[i][1] & 0xff;
	  mgl_draw_font( x, y, code, DIR_SOUTH );
	  y -= size;
	  sprintf( str, "%2d", koma_sum[GOTE][i] );
	  mgl_draw_string( x, y, str, DIR_SOUTH );
	}
}


/* MouseKomaDraw(x,y,koma_type,control)
 * ޥư˹碌ƶ
 * x,y:			ɸ
 * koma_type:	Υ
 * control:		
 */
void
MouseKomaDraw(int x, int y, int koma_type, int control)
{
#ifndef SMG_MGL1
  /* եå */
  if ( !gOptText ) {
	mgl_bitblt( NULL, x, y,
				koma_screen[control][koma_type], 0, 0,
				koma_screen[control][koma_type]->width,
				koma_screen[control][koma_type]->height,
				BLT_MASKING + WHITE
				);
	return;
  }
#endif
  /* ƥȶ */
  mgl_set_font( gFontSize.y, FA_NORMAL );
  mgl_set_color( BLACK );
  switch( control ) {
	int code;
  case SENTE :	/* ξ */
	code = (koma_sente[koma_type][0] << 8) & 0xffff;
	code |= koma_sente[koma_type][1] & 0xff;
	mgl_draw_font( x, y, code, DIR_NORTH );
	break;
	
  case GOTE :	/* ξ */
	code = (koma_gote[koma_type][0] << 8) & 0xffff;
	code |= koma_gote[koma_type][1] & 0xff;
	x += gFontSize.x*2;
	y += gFontSize.y;
	mgl_draw_font( x, y, code, DIR_SOUTH );
	break;
	
  default :
	break;
  }
}


/* KomaSetup()
 * եåΥåȥå
 */
void
KomaSetup(void)
{
#ifndef SMG_MGL1
  int i,j;
  for (j=0; j<TEBAN_NUM; j++) {
	for (i=0; i<KOMA_TYPE_MAX; i++) {
	  koma_screen[j][i] = mgl_conv_screen_from_mgr( koma_mgl2[j][i],
													STK_GENERIC_192COLOR );
	}
  }
  return;
#endif
  gOptText = TRUE;	/* MGL1 ϥƥɽ */
}


/* KomaFree()
 * եåγ
 */
void
KomaFree(void)
{
#ifndef SMG_MGL1
  int i,j;
  for (j=0; j<TEBAN_NUM; j++) {
	for (i=0; i<KOMA_TYPE_MAX; i++) {
	  mgl_free_screen( koma_screen[j][i] );
	}
  }
#endif
}
