/***********************************************************
 * mglFile.c
 * Хե
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: mglFile.c,v 1.4 2000/08/01 15:45:44 satofumi Exp $
 **********************************************************/
#define _MGLFILE_C_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "../core/global.h"
#include "../core/Main.h"
#include "../core/Sef.h"
#include "system.h"
#include "mglFile.h"
#include "mglMain.h"
#include "mglTime.h"
#include "mglGame.h"
#include "mglConsl.h"
#include "mglRs232.h"
#include "mglMove.h"


/* ؿ */
static int GetInteger(char *str);
static int GetTwoInteger(char *str, int num);

/*------------------------------------------------------------mglFile.c */
/* GetInteger(str)
 * ɤ߹
 * in:	str		ʸ
 * out:			
 */
static int
GetInteger(char *str)
{
	while( *str != ':' ) str++;
	str++;
	while( *str == ' ' || *str == '\t' ) str++;
	return atoi(str);
}


/* GetTwoInteger(str,num)
 * ʣġˤɤ߹
 * in:	str		ʸ
 *		num		 position(0), value(1) ?
 * out:			
 * աδؿϡvalue ˵뤳ȡ
 *       Ǥʤȡstrtok()  ','  null ˤƤޤᡢ
 *       顼ˤʤ롣
 */
static int
GetTwoInteger(char *str, int num)
{
	char *p;

	if( num==0 ) {	/* position ߤ */
		while( *str != ':' ) str++;
		str++;
		while( *str == ' ' || *str == '\t' ) str++;
		p = strtok( str, "," );
		return atoi( p );
	}
	else {	/* value ߤ */
		while( *str != ',' ) str++;
		str++;
		while( *str == ' ' || *str == '\t' ) str++;
		return atoi(str);
	}
}


/* IniLoad(teban_ini)
 * iniեɤ߹
 * out: TRUE	
 *		FALSE	
 */
boolean
IniLoad(int iteban)
{
	FILE *fp_ini;
	unsigned char buf[256], fstr[256];
	int i,j;

	/* open file */
	if( iteban==SENTE ) {
		fp_ini = fopen( gIni_file_sente, OPENMODE_READ_TEXT );
		printf( "%s loading...", gIni_file_sente );
		if( fp_ini==NULL ) {
		  printf("not found!\n");
		  sprintf( gIni_file_sente, "%s/%s", USER_INI_DIR, INI_FILE_SENTE );
		  fp_ini = fopen( gIni_file_sente, OPENMODE_READ_TEXT );
		  printf( "%s loading...", gIni_file_sente );
		  if( fp_ini==NULL ) {
			printf("not found!\nLoad failed!\n");
			return FALSE;
		  }
		}
	} else {
		fp_ini = fopen( gIni_file_gote, OPENMODE_READ_TEXT );
		printf( "%s loading...", gIni_file_gote );
		if( fp_ini==NULL ) {
		  printf("not found!\n");
		  sprintf( gIni_file_gote, "%s/%s", USER_INI_DIR, INI_FILE_GOTE );
		  fp_ini = fopen( gIni_file_gote, OPENMODE_READ_TEXT );
		  printf( "%s loading...", gIni_file_gote );
		  if( fp_ini==NULL ) {
			printf("not found!\nLoad failed!\n");
			return FALSE;
		  }
		}
	}

	/* DATAɤ߹ */
	while( fgets(buf,256,fp_ini) != NULL ) {
		if( buf[0]=='\n' || buf[0]=='#' )
			continue;
		/* õ */
		if( strncmp(buf, "DEPTH_MAX:", 10) == 0 ){
			gIni_DepthMax[iteban] = GetInteger(buf);
		/* ο */
		}else if( strncmp(buf, "SASITE_MAX:", 11) == 0 ){
			gIni_SasiteMax[iteban] = GetInteger(buf);
		/* Sef- */
		}else if( strncmp(buf, "Sef_JOBAN_coefA:", 16) == 0 ){
			gSef_SefCoef[iteban][JOBAN][0] = GetInteger(buf);
		}else if( strncmp(buf, "Sef_JOBAN_coefB:", 16) == 0 ){
			gSef_SefCoef[iteban][JOBAN][1] = GetInteger(buf);
		}else if( strncmp(buf, "Sef_JOBAN_coefC:", 16) == 0 ){
			gSef_SefCoef[iteban][JOBAN][2] = GetInteger(buf);
		/* Sef- */
		}else if( strncmp(buf, "Sef_CHUBAN_coefA:", 17) == 0 ){
			gSef_SefCoef[iteban][CHUBAN][0] = GetInteger(buf);
		}else if( strncmp(buf, "Sef_CHUBAN_coefB:", 17) == 0 ){
			gSef_SefCoef[iteban][CHUBAN][1] = GetInteger(buf);
		}else if( strncmp(buf, "Sef_CHUBAN_coefC:", 17) == 0 ){
			gSef_SefCoef[iteban][CHUBAN][2] = GetInteger(buf);
		/* Sef- */
		}else if( strncmp(buf, "Sef_SHUBAN_coefA:", 17) == 0 ){
			gSef_SefCoef[iteban][SHUBAN][0] = GetInteger(buf);
		}else if( strncmp(buf, "Sef_SHUBAN_coefB:", 17) == 0 ){
			gSef_SefCoef[iteban][SHUBAN][1] = GetInteger(buf);
		}else if( strncmp(buf, "Sef_SHUBAN_coefC:", 17) == 0 ){
			gSef_SefCoef[iteban][SHUBAN][2] = GetInteger(buf);

		/* Tef- */
		}else if( strncmp(buf, "Tef_JOBAN_coefA:", 16) == 0 ){
			gSef_TefCoef[iteban][JOBAN][0] = GetInteger(buf);
		}else if( strncmp(buf, "Tef_JOBAN_coefB:", 16) == 0 ){
			gSef_TefCoef[iteban][JOBAN][1] = GetInteger(buf);
		}else if( strncmp(buf, "Tef_JOBAN_coefC:", 16) == 0 ){
			gSef_TefCoef[iteban][JOBAN][2] = GetInteger(buf);
		/* Tef- */
		}else if( strncmp(buf, "Tef_CHUBAN_coefA:", 17) == 0 ){
			gSef_TefCoef[iteban][CHUBAN][0] = GetInteger(buf);
		}else if( strncmp(buf, "Tef_CHUBAN_coefB:", 17) == 0 ){
			gSef_TefCoef[iteban][CHUBAN][1] = GetInteger(buf);
		}else if( strncmp(buf, "Tef_CHUBAN_coefC:", 17) == 0 ){
			gSef_TefCoef[iteban][CHUBAN][2] = GetInteger(buf);
		/* Tef- */
		}else if( strncmp(buf, "Tef_SHUBAN_coefA:", 17) == 0 ){
			gSef_TefCoef[iteban][SHUBAN][0] = GetInteger(buf);
		}else if( strncmp(buf, "Tef_SHUBAN_coefB:", 17) == 0 ){
			gSef_TefCoef[iteban][SHUBAN][1] = GetInteger(buf);
		}else if( strncmp(buf, "Tef_SHUBAN_coefC:", 17) == 0 ){
			gSef_TefCoef[iteban][SHUBAN][2] = GetInteger(buf);

		/* β */
		}else if( strncmp(buf, "KING:", 5) == 0 ){
			gSef_PointKoma[iteban][KING] = GetInteger(buf);
		}else if( strncmp(buf, "GOLD:", 5) == 0 ){
			gSef_PointKoma[iteban][GOLD] = GetInteger(buf);
		}else if( strncmp(buf, "BISHOP:", 7) == 0 ){
			gSef_PointKoma[iteban][BISHOP] = GetInteger(buf);
		}else if( strncmp(buf, "ROOK:", 5) == 0 ){
			gSef_PointKoma[iteban][ROOK] = GetInteger(buf);
		}else if( strncmp(buf, "SILVER:", 7) == 0 ){
			gSef_PointKoma[iteban][SILVER] = GetInteger(buf);
		}else if( strncmp(buf, "KNIGHT:", 7) == 0 ){
			gSef_PointKoma[iteban][KNIGHT] = GetInteger(buf);
		}else if( strncmp(buf, "LANCE:", 6) == 0 ){
			gSef_PointKoma[iteban][LANCE] = GetInteger(buf);
		}else if( strncmp(buf, "PAWN:", 5) == 0 ){
			gSef_PointKoma[iteban][PAWN] = GetInteger(buf);
		}else if( strncmp(buf, "ReBISHOP:", 9) == 0 ){
			gSef_PointKoma[iteban][ReBISHOP] = GetInteger(buf);
		}else if( strncmp(buf, "ReROOK:", 7) == 0 ){
			gSef_PointKoma[iteban][ReROOK] = GetInteger(buf);
		}else if( strncmp(buf, "ReSILVER:", 9) == 0 ){
			gSef_PointKoma[iteban][ReSILVER] = GetInteger(buf);
		}else if( strncmp(buf, "ReKNIGHT:", 9) == 0 ){
			gSef_PointKoma[iteban][ReKNIGHT] = GetInteger(buf);
		}else if( strncmp(buf, "ReLANCE:", 8) == 0 ){
			gSef_PointKoma[iteban][ReLANCE] = GetInteger(buf);
		}else if( strncmp(buf, "RePAWN:", 7) == 0 ){
			gSef_PointKoma[iteban][RePAWN] = GetInteger(buf);
		/*  */
		}else if( strncmp(buf, "RAND_MAX:", 9) == 0 ){
			gSef_RandMax[iteban] = GetInteger(buf) + 1;

		/* Ȥ */
		}else if( strncmp(buf, "NUMBER_OF_FORMATION:", 20) == 0 ){
			gSef_SenkeiMax[iteban] = GetInteger(buf);
		}else if( strncmp(buf, "FORMATION:", 10) == 0 ){
			gSef_Senkei[iteban] = GetInteger(buf);
			if( gSef_Senkei[iteban]>=gSef_SenkeiMax[iteban] )
			  gSef_Senkei[iteban]=0;
		}else if( strncmp(buf, "FORMATION_", 10) == 0 ){
			for( j=0;j<gSef_SenkeiMax[iteban];j++ ) {
				for( i=0;i<KOMA_NUM/2;i++ ) {	/* ֤Τ */
					sprintf( fstr, "FORMATION_%1d_%02d", j, i );
					if( strncmp(buf, fstr, 14) == 0 ){
						gSef_Kakoi[iteban][j][i].value = GetTwoInteger(buf,1);
						gSef_Kakoi[iteban][j][i].zahyo = GetTwoInteger(buf,0);
						gSef_Kakoi[iteban][j][20+i].value
						  = gSef_Kakoi[iteban][j][i].value;
						gSef_Kakoi[iteban][j][20+i].zahyo
						  = BAN_NUM - gSef_Kakoi[iteban][j][i].zahyo - 1;
						/*{
						char str[256];
						sprintf( str,	"gSef_Kakoi[%d][%d][%d].value = %d\n"
										"gSef_Kakoi[%d][%d][%d].zahyo = %d\n"
										"gSef_Kakoi[%d][%d][%d].value = %d\n"
										"gSef_Kakoi[%d][%d][%d].zahyo = %d\n",
								iteban,j,i,gSef_Kakoi[iteban][j][i].value,
								iteban,j,i,gSef_Kakoi[iteban][j][i].zahyo,
								iteban,j,20+i,gSef_Kakoi[iteban][j][20+i].value,
								iteban,j,20+i,gSef_Kakoi[iteban][j][20+i].zahyo );
						DispError( str );
						}*/
					}
				}
			}
		/* ¾ */
		}else{
			printf("%s <- mismatch\n",buf);
			return FALSE;
		}
	}
	/* close file */
	fclose(fp_ini);
	printf("done\n");

	return TRUE;
}


/* CsaInit(sban,gban)
 * (CSA)ν
 */
void
CsaInit(int sban, int gban)
{
	char str[20];
	char *control_str[3] = { "Player", "MobileGear", "RS232C" };
	FILE *fp;

	fp = fopen( gCsa_file, OPENMODE_WRITE_TEXT );
	if( fp==NULL ) return;
	fputs( "'жɼ̾\n", fp );
	sprintf( str, "N+%s\n", control_str[sban] );
	fputs( str, fp );
	sprintf( str, "N-%s\n", control_str[gban] );
	fputs( str, fp );
	fputs( "'ʿ\n", fp );
	fputs( "PI\n", fp );
	fputs( "'\n", fp );
	fputs( "+\n", fp );
	fputs( "'ؤȾ\n", fp );
	fclose( fp );

	#ifdef LOG
	{
	extern char *log_file;
	fp = fopen( log_file, OPENMODE_WRITE_TEXT );
	if( fp==NULL ) return;
	fclose( fp );
	}
	#endif
}


/* CsaMake(type,prev,next,control)
 * (CSA)
 * in:	type		μ0-13
 *		prev		ưκɸ
 *		next		ưκɸ
 *		control		SENTE or GOTE
 *		str			¸ʸؿ
 */
void
CsaMake(int type, int prev, int next, int control, char *str)
{
	int px,py,nx,ny;
	char *type_name[KOMA_TYPE_MAX] = {
		"OU","KI","HI","KA","GI","KE","KY","FU",
		"RY","UM","NG","NK","NY","TO",
	};

	/* ưκɸ */
	if( prev < HAND ) {
		px = BAN_YOKO - zahyo_x(prev);	/* ɸ */
		py = zahyo_y(prev) + 1;			/* ɸ */
	} else {
		px = 0;		/*  */
		py = 0;		/*  */
	}
	/* ưκɸ */
	nx = BAN_YOKO - zahyo_x(next);	/* ɸ */
	ny = zahyo_y(next) + 1;			/* ɸ */

	if( control==SENTE )
		sprintf( str, "+%1d%1d%1d%1d%s", px,py,nx,ny, type_name[type] );
	else
		sprintf( str, "-%1d%1d%1d%1d%s", px,py,nx,ny, type_name[type] );
}


/* CsaSave(type,prev,next,control)
 * ե(CSA)ؤν
 * in:	type		μ0-13
 *		prev			ưκɸ
 *		next			ưκɸ
 *		control		SENTE or GOTE
 */
void
CsaSave(int type, int prev, int next, int control)
{
	char str[20];

	CsaMake( type, prev, next, control, str );	/* (CSA) */
	/* ե¸ */
	strcat( str, "\n" );
	CsaPuts( str, gCsa_file );	/* ؤ¸ */
	sprintf( str, "T%d\n", gTimeThink );
	CsaPuts( str, gCsa_file );	/* ֤¸ */
}


/* CsaLoad(csa_tesuu,fp_tmp)
 * ե(CSA)
 * in:	tesuu	Ƹ̤ޤǤμ
 * ߤʿκǽζ̤Τߥݡ
 */
boolean
CsaLoad(int csa_tesuu, FILE *fp_tmp)
{
	unsigned char buf[256];
	int _sente_ban, _gote_ban;

	/* ѿν */
	_sente_ban = gSente_ban;
	_gote_ban = gGote_ban;
	gSente_ban = RS232C;
	gGote_ban = RS232C;
	rewind( fp_tmp );	/* եƬذư */
	VariableInit();		/* ѿ */
	CsaInit(_sente_ban,_gote_ban);	/* եCSAˤ */
	ClearKifuWindow();	/* Υꥢ */

	/* DATAɤ߹ */
	while( fgets(buf,256,fp_tmp)!=NULL && gTesuu<csa_tesuu ) {
		if( buf[0]=='\n' || buf[0]=='\'' )
			continue;
		if( !isalnum(buf[1]) )
			continue;
		if( buf[0]=='+' && gTeban==SENTE ) {
			if( !Rs232cMove(buf) ||
				!KomaMove( gMove_prev, gMove_next, gTeban, gMove_change ) ){
				DispError( "sente error!" );
				return FALSE;
			}
			//if( !KomaMove(gMove_prev,gMove_next,gTeban,gMove_change) ) return FALSE;
		}else if( buf[0]=='-' && gTeban==GOTE ) {
			if( !Rs232cMove(buf) ||
				!KomaMove( gMove_prev, gMove_next, gTeban, gMove_change ) ){
				DispError( "gote error!" );
				return FALSE;
			}
		}else if( buf[0]=='T' ) {
			gTimeTotal[gTeban] += atoi(&buf[1]);
			if( gTeban==SENTE ) {
				gTeban = GOTE;
				gPlayerStock = GOTE_STOCK;
			} else {
				gTeban = SENTE;
				gPlayerStock = SENTE_STOCK;
			}
			gTesuu++;
		}else if( buf[0]=='%' ) {
			break;
		}else {
			continue;
		}
		CsaPuts( buf, gCsa_file );	/* ե¸ */
	}
	gSente_ban = _sente_ban;
	gGote_ban = _gote_ban;
	return TRUE;
}


/* CsaPuts(str,file)
 * ե(CSA)˽񤭹
 */
boolean
CsaPuts(char *str, char *file)
{
	FILE *fp;

	fp = fopen( file, OPENMODE_ADD_TEXT );
	if( fp==NULL ) return FALSE;
	fputs( str, fp );
	fclose( fp );
	return TRUE;
}
