/***********************************************************
 * mglGame.c
 * Хؿ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: mglGame.c,v 1.3 2000/08/08 14:27:50 satofumi Exp satofumi $
 **********************************************************/
#define _MGLGAME_C_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
//#include <ctype.h>
#include "../core/global.h"
#include "../core/Main.h"
#include "../core/Sef.h"
#include "system.h"
#include "mglGame.h"
#include "mglMain.h"
#include "mglDisp.h"
#include "mglConsl.h"
#include "mglFile.h"
#include "mglTime.h"
#include "mglPlay.h"
#include "mglRs232.h"
#include "mglMove.h"

#ifdef SMG_MGL1
#include <mgl.h>	/* mgl1 */
#else
#include <mgl2.h>	/* mgl2 */
#endif


/* ؿѿ */
static void FieldInit(void);
static void FieldFinalize(void);
static boolean Taikyoku(void);

/** ֹ *******************************
   9    7    5    3    0    4    6    8   10
NONE    1 NONE NONE NONE NONE NONE    2 NONE
  11   12   13   14   15   16   17   18   19
NONE NONE NONE NONE NONE NONE NONE NONE NONE
NONE NONE NONE NONE NONE NONE NONE NONE NONE
NONE NONE NONE NONE NONE NONE NONE NONE NONE
  39   38   37   36   35   34   33   32   31
NONE   22 NONE NONE NONE NONE NONE   21 NONE
  30   27   26   24   20   23   25   27   29
*******************************************/
static KomaDef _koma[KOMA_NUM_PLUS] = {
	/* type, zahyo, control, role */
	{ KING, 4, GOTE, OFF },	/* No.0 */
	{ BISHOP, 10, GOTE, OFF },
	{ ROOK, 16, GOTE, OFF },
	{ GOLD, 3, GOTE, OFF },
	{ GOLD, 5, GOTE, OFF },
	{ SILVER, 2, GOTE, OFF },
	{ SILVER, 6, GOTE, OFF },
	{ KNIGHT, 1, GOTE, OFF },
	{ KNIGHT, 7, GOTE, OFF },
	{ LANCE, 0, GOTE, OFF },
	{ LANCE, 8, GOTE, OFF },	/* No.10 */
	{ PAWN, 18, GOTE, OFF },
	{ PAWN, 19, GOTE, OFF },
	{ PAWN, 20, GOTE, OFF },
	{ PAWN, 21, GOTE, OFF },
	{ PAWN, 22, GOTE, OFF },
	{ PAWN, 23, GOTE, OFF },
	{ PAWN, 24, GOTE, OFF },
	{ PAWN, 25, GOTE, OFF },
	{ PAWN, 26, GOTE, OFF },
	{ KING, 76, SENTE, OFF },	/* No.20 */
	{ BISHOP, 70, SENTE, OFF },
	{ ROOK, 64, SENTE, OFF },
	{ GOLD, 77, SENTE, OFF },
	{ GOLD, 75, SENTE, OFF },
	{ SILVER, 78, SENTE, OFF },
	{ SILVER, 74, SENTE, OFF },
	{ KNIGHT, 79, SENTE, OFF },
	{ KNIGHT, 73, SENTE, OFF },
	{ LANCE, 80, SENTE, OFF },
	{ LANCE, 72, SENTE, OFF },	/* No.30 */
	{ PAWN, 62, SENTE, OFF },
	{ PAWN, 61, SENTE, OFF },
	{ PAWN, 60, SENTE, OFF },
	{ PAWN, 59, SENTE, OFF },
	{ PAWN, 58, SENTE, OFF },
	{ PAWN, 57, SENTE, OFF },
	{ PAWN, 56, SENTE, OFF },
	{ PAWN, 55, SENTE, OFF },
	{ PAWN, 54, SENTE, OFF },
	{ NO_TYPE, NO_ZAHYO, NO_CONTROL, NO_ROLE },
};

/*------------------------------------------------------------mglGame.c */
/* Game()
 * Ϥᡪ
 */
void
Game(void)
{
	VariableInit();	/* ѿ */
	FieldInit();	/* ̤ */
	CsaInit(gSente_ban,gGote_ban);/* եCSAˤ */
	DispMessage( "жɳϡ", NO_BUTTON );
	while( Taikyoku() ) {}		/* жɳ (^^)v */
	FieldFinalize();
}


/* VariableInit()
 * ѿ
 */
void
VariableInit(void)
{
	unsigned int seed, i;

	/* 𡦥եɤν */
	memcpy( gKoma, _koma, sizeof(KomaDef)*KOMA_NUM_PLUS );
	for(i=1;i<FIELD_MAX;i++)
		gField[i] = NONE;	/* NONEˤ */
	for(i=0;i<KOMA_NUM;i++)	/*  */
		gField[ gKoma[i].zahyo ] = i;	/* ֹ */
	/* ѿν */
	gTesuu = 1;
	gTeban = SENTE;
	gPlayerStock = SENTE_STOCK;
	gCursor_x = 4;
	gCursor_y = 4;
	gSituation = JOBAN;
	gMove_next = BAN_NUM + 1;
	/* ޡν */
	gTimeTotal[SENTE] = 0;
	gTimeTotal[GOTE] = 0;
	/* ν */
	seed = (unsigned int)time( 0 );
	srand( seed );
	/* ﷿Υʷ */
	for(i=0;i<TEBAN_NUM;i++) {
		if( gSef_Senkei[i]<0 && gSef_SenkeiMax[i]>0 )
		  gSef_Senkei[i] = rand() % gSef_SenkeiMax[i];
		/*{
		char str[256];
		sprintf( str, "gSef_Senkei[%d] = %d", i, gSef_Senkei[i] );
		DispError( str );
		}*/
	}
}


/* FieldInit()
 * ̽
 */
static void
FieldInit(void)
{
#ifdef SMG_MGL1
    SetDisplayLayout( 640, 240 );
	SetConsoleLayout( 640, 240 );
	ShogibanDraw( 640, 240 );	/*  */
#else
    SetDisplayLayout( SCREEN_WIDTH, SCREEN_HEIGHT );
	SetConsoleLayout( SCREEN_WIDTH, SCREEN_HEIGHT );
	ShogibanDraw( SCREEN_WIDTH, SCREEN_HEIGHT );	/*  */
#endif
	KomaSetup();	/* եå򥻥åȥå */
	WakuDraw( SCREEN_WIDTH, SCREEN_HEIGHT );	/* Ȥ */
	ReDraw( TRUE );	/* ¤٤ */
}


/* FieldFinalize()
 * ̽λ
 */
static void
FieldFinalize(void)
{
	WakuDrawEnd();	/* Ȥ */
	KomaFree();	/* եå */
}


/* Taikyoku()
 * ж
 * out: TRUE	ж³
 *      FALSE	жɽλ
 */
static boolean
Taikyoku(void)
{
    int ret;
	TimerSet( gTeban );	/* ¬ */
	switch( gTeban==SENTE?gSente_ban:gGote_ban ) {
		case PLAYER:
			ret = PlayerThink();
			if( ret==PT_GO ) break;
			if( ret==PT_QUIT ) return FALSE;	/* quit */
			if( MattaMode() ) return TRUE;	/* continue */
			return FALSE;	/* λ */
		case MOBA:
			if( !MobaThink() ) {
				TORYOMessage( gTeban );	/* λ */
				if ( MattaMode() ) return TRUE;
			    return FALSE;	/* Фλ */
			}
			ret = mgl_get_key(SMG_NOWAIT);
			/* Ǥʤмưѡ */
			if( ret=='q' ) return FALSE;
			if( ret!=SMG_ESC ) break;
			/* ESC 줿 */
			ret = MattaMode();
			return ret;
		case RS232C:
			if( Rs232cThink() ) break;
			if( MattaMode() ) return TRUE;	/* continue */
			return FALSE;	/* ̿λ */
		default:
			break;
	}
	/* ư */
	if( !KomaMove( gMove_prev, gMove_next, gTeban, gMove_change ) ) {
	  if ( MattaMode() ) return TRUE;
	  return FALSE;
	}
	ReDraw( FALSE );
	/* ¬λ */
	TimerStop( gTeban );
	/* CSAե¸ */
	CsaSave( gKoma[gField[gMove_next]].type, gMove_prev, gMove_next, gTeban );
	/* ̿ */
	Rs232cSendMove( gKoma[gField[gMove_next]].type,
					gMove_prev, gMove_next, gTeban );

	gTesuu++;	/* 䤷ơ*/
	if( gTeban==SENTE ) {
		gTeban = GOTE;
		gPlayerStock = GOTE_STOCK;
	} else {
		gTeban = SENTE;
		gPlayerStock = SENTE_STOCK;
	}
	return TRUE;
}
