/***********************************************************
 * mglRs232.c
 * ̿ؿ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: mglRs232.c,v 1.1 2000/07/26 12:39:11 satofumi Exp $
 **********************************************************/
#define _MGLRS232_C_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "../core/global.h"
#include "../core/Main.h"
#include "../core/Movable.h"
#include "system.h"
#include "mglRs232.h"
#include "mglMain.h"
#include "mglGame.h"
#include "mglDisp.h"
#include "mglArch.h"
#include "mglFile.h"
#include "mglConsl.h"


/* ؿ */
static int Rs232cPut(int px, int py, int type);

/*------------------------------------------------------------mglRs232.c */
/* Rs232cThink()
 * ̿λ׹
 */
boolean
Rs232cThink(void)
{
	unsigned char str[256];
	int i;

	if( !ComReceive(str) ) return FALSE;	/*  */
	i = 1;
	while( !(isalnum(str[i])) ) i++;	/* ̣Τǽʸ򸫤Ĥ */
	if( str[i-1]=='+' && gTeban==GOTE ) return FALSE;
	if( str[i-1]=='-' && gTeban==SENTE ) return FALSE;

	switch( str[i-1] ) {
		case '+':	/* ̾λؤξ */
		case '-':
			if( !Rs232cMove(str) ) return FALSE;
			break;

		case '%':	/* åξ */
			if( strncmp(str+i,"TORYO",5)==0 ) TORYOMessage(gTeban);
			return FALSE;

		default:	/* ʬ */
			i++;
			while( !(isalnum(str[i])) ) i++;
	}
	return TRUE;
}


/* Rs232cMove()
 * ̿λؤˤĤ
 */
boolean
Rs232cMove(unsigned char *str)
{
	unsigned char k_type[3];
	int length,type,change,px,py,prev,nx,ny,next,i;

	length = strlen( str );
	i = 1;
	/* px py nx ny  */
	while( !(isdigit(str[i])) ) i++;	/* οϡ */
	if( i>length ) return FALSE;
	px = str[i++] - '0';				/* ưΣɸ */
	while( !(isdigit(str[i])) ) i++;	/* οϡ */
	if( i>length ) return FALSE;
	py = str[i++] - '0';				/* ưΣɸ */
	while( !(isdigit(str[i])) ) i++;	/* οϡ */
	if( i>length ) return FALSE;
	nx = str[i++] - '0';				/* ưΣɸ */
	while( !(isdigit(str[i])) ) i++;	/* οϡ */
	if( i>length ) return FALSE;
	ny = str[i++] - '0';				/* ưΣɸ */
	while( !(isalpha(str[i])) ) i++;	/* ʸϡ */
	if( i>length ) return FALSE;
	k_type[0] = str[i++];				/* μࣱʸ */
	while( !(isalpha(str[i])) ) i++;	/* ʸϡ */
	if( i>length ) return FALSE;
	k_type[1] = str[i++];				/* μࣲʸ */

	//	k_type[2] = NULL;
	k_type[2] = '\0';

	if( strcmp(k_type,"OU")==0 ) {	/* ̾ */
		type = KING;
	}else if( strcmp(k_type,"KI")==0 ) {
		type = GOLD;
	}else if( strcmp(k_type,"HI")==0 ) {
		type = BISHOP;
	}else if( strcmp(k_type,"KA")==0 ) {
		type = ROOK;
	}else if( strcmp(k_type,"GI")==0 ) {
		type = SILVER;
	}else if( strcmp(k_type,"KE")==0 ) {
		type = KNIGHT;
	}else if( strcmp(k_type,"KY")==0 ) {
		type = LANCE;
	}else if( strcmp(k_type,"FU")==0 ) {
		type = PAWN;
	}else if( strcmp(k_type,"RY")==0 ) {	/*  */
		type = ReBISHOP;
	}else if( strcmp(k_type,"UM")==0 ) {
		type = ReROOK;
	}else if( strcmp(k_type,"NG")==0 ) {
		type = ReSILVER;
	}else if( strcmp(k_type,"NK")==0 ) {
		type = ReKNIGHT;
	}else if( strcmp(k_type,"NY")==0 ) {
		type = ReLANCE;
	}else if( strcmp(k_type,"TO")==0 ) {
		type = RePAWN;
	}else {
		DispError( "顼" );
		return FALSE;
	}
	if( type>PAWN ) 
		change = TRUE;	/* ѿȤ⤷ʤ */
	else
		change = FALSE;	/* Τޤ */

	prev = Rs232cPut( px, py, type );	/* ǤȽޤ */
	next = zahyo( BAN_YOKO-nx, ny-1 );

	if( prev<0 ) return FALSE;

	if( !Movable(prev,next,gField,gKoma) ) {	/* ưǽǧ */
		DispError( "Movable error!" );
		return FALSE;
	}
	/* ư */
	RegistMove( prev, next, change );

	return TRUE;
}


/* Rs232cPut()
 * ̿ζǤȽޤɸη׻
 * in:	px,py>0 Τޤ޷׻
 *		px=py=0 ǤʤΤǤζκɸ֤
 * out:	prev>=0	ɸ or Ǥ
 *		prev<0	ǤĶ𤬤ʤ
 */
static int
Rs232cPut(int px, int py, int type)
{
	int i;

	if( px!=0 || py!=0 ) {
		i = zahyo( BAN_YOKO-px, py-1 );
		return i;	/* ǤʤϤΤޤ޷׻ */
	}
	gKoma[NONE].type = KING;
	for( i=gPlayerStock; i<gPlayerStock+STOCK_MAX; i++ ) {
		if( gKoma[gField[i]].type==type ) return i;
	}
	DispError( "𤬸Ĥޤ" );
	return -1;	/* ʶϤʤ */
}


/* Rs232cSendMove(type,prev,next,control)
 * com ݡȤ˻ؤ
 * in:	type		μ0-13
 *		prev			ưκɸ
 *		next			ưκɸ
 *		control		SENTE or GOTE
 */
void
Rs232cSendMove(int type, int prev, int next, int control)
{
	char str[20];

	/* ꤬̿ʤؤ㤦ʤreturn!! */
	if( gTeban==SENTE && (gGote_ban!=RS232C || gSente_ban==RS232C) ) return;
	if( gTeban==GOTE  && (gSente_ban!=RS232C || gGote_ban==RS232C) ) return;

	CsaMake( type, prev, next, control, str );	/* (CSA) */
	ComSend( str );		/*  */
}
